<%--
 * Copyright by Intland Software
 *
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Intland Software. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Intland.
 *
 * $Revision$ $Date$
--%>

<%@ taglib uri="jstl-c" prefix="c" %>
<%@ taglib uri="jstl-fn" prefix="fn" %>


<%@ taglib uri="http://displaytag.sf.net" prefix="display" %>

<%@ taglib uri="taglib" prefix="tag" %>
<%@ taglib uri="uitaglib" prefix="ui" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>

<c:set var="dragDropDeleteEnabled" value="${canEditApprovalWorkflow && !isApprovalWorkflowInUse && fn:length(artifactApprovalSteps) > 1}" />

<c:set var="DEBUG" value="false"/>
<c:if test="${canEditApprovalWorkflow && isApprovalWorkflowInUse}">
	<div class="warning">
		Steps can not be modified, because this approval workflow is in use by
		<a href="<c:url value='/listArtifactsInApproval.spr?approvalworkflow_id=${artifactApproval.id}' />" title='View the wiki pages and documents using this approval workflow'>${numberOfArtifactsUseThisWorkflow}</a>
		wiki pages and documents.
	</div>
</c:if>

<ui:title style="top-sub-headline-decoration" bottomMargin="5" separatorGapHeight="2" titleStyle="" topMargin="5" header="Approval Steps" />

<display:table requestURI="" defaultsort="0" defaultorder="descending" export="false" class="expandTable dragReorder" htmlId="artifactApprovalStepsTable"
	cellpadding="0" name="${artifactApprovalSteps}" id="step" >
	<display:column title="Step" headerClass="numberData" class="numberData ordinalNumber">
		<spring:bind path="approvalStepOrdering['${step.id}']">
			<c:set var="orderValue" value="${status.value}" />
		</spring:bind>

		<c:if test="${dragDropDeleteEnabled}">
			<%--
			<form:radiobutton id="selectedStep_${step.id}" path="selectedStep" value="${step.id}" />
			--%>
			<input name="approvalStepOrdering['${step.id}']" value="${orderValue}" title='ordinal number for step.id=${step.id}'
				<c:if test="${! DEBUG}"> type='hidden' </c:if>
			/>
		</c:if>
		<span class="ordinalNumberLabel">${step_rowNum}</span>
	</display:column>

	<display:column class="${COLUMN_SEPARATOR}" media="html" decorator="com.intland.codebeamer.ui.view.table.TrimmedColumnDecorator" />

	<display:column title="Name" headerClass="textData" class="textData">
		<c:out value="${step.name}"/>
		<%-- TODO: (Final) text is not is not printed, because it would be invalid when reordering
		<c:if test="${step.finalStep}"><span class="subtext">(Final)</span></c:if>
		--%>
	</display:column>

	<c:if test="${!readOnly}">
		<display:column media="html" class="action-column-minwidth">
			<ui:actionMenu builder="artifactApprovalStepListContextActionMenuBuilder" subject="${step}" />
		</display:column>
	</c:if>

	<display:column class="${COLUMN_SEPARATOR}" media="html" decorator="com.intland.codebeamer.ui.view.table.TrimmedColumnDecorator" />

	<display:column title="Approvers" headerClass="textData expand" class="textData">
		<c:set var="approvers" value="${step.approvers}" />
		<c:choose>
			<c:when test="${!empty approvers}">
				<%--first the Users: --%>
				<c:set var="approverUsers" value="${step.approverUsers}"/>
				<c:forEach var="approverUser" items="${approverUsers}" varStatus="varStatus">
					<tag:userLink user_id="${approverUser.id}" />
					<c:if test="${!varStatus.last}">,</c:if>
				</c:forEach>
				<c:if test="${! empty approverUsers}">
					<br/>
				</c:if>
				<%-- followed by the roles --%>
				<c:set var="approverRoles" value="${step.approverRoles}" />
				<c:if test="${! empty approverRoles}">
					<c:forEach var="approverRole" items="${approverRoles}" varStatus="varStatus">
						<c:if test="${!empty approverRole}"><b>${approverRole.name}</b> role</c:if>
						<c:if test="${!varStatus.last}">,</c:if>
					</c:forEach>
				</c:if>
			</c:when>
			<c:otherwise>
				<span class="warningtext">No approvers defined.</span>
			</c:otherwise>
		</c:choose>
	</display:column>
</display:table>

<div style="margin-top: 5px" class="subtext">
	<c:if test="${dragDropDeleteEnabled}">(Hint: drag and drop the lines above to reorder the steps.)</c:if>
</div>

<c:if test="${dragDropDeleteEnabled}">
	<ui:delayedScript>
	<script type="text/javascript" src="<ui:urlversioned value="/docs/approvals/ApprovalStepReorderHandler.js" />"></script>
	<script type="text/javascript">
		// debug function to print orders
		function printOrders() {
			var form = document.getElementById("createUpdateArtifactApprovalForm");
			var msg = "";
			for (var i=0; i<form.elements.length;i++) {
				var elem = form.elements[i];
				msg += elem.name +"=" + elem.value +", ";
			}
			YAHOO.log("form elements:" + msg);
		}

		YAHOO.util.Event.onDOMReady(function() {
			var tableReorderController = new TableReorder("artifactApprovalStepsTable");
			// wire the custom event handlers
			tableReorderController.onSwapRowEvent.subscribe(ApprovalStepReorderHandler.onSwapOfSteps);
			tableReorderController.onEndDrag.subscribe(ApprovalStepReorderHandler.showChangedMessage);
		});
	</script>
	</ui:delayedScript>

	<c:if test="${DEBUG}">
		<div class="debug">
			<input type='button' class='button' onclick="printOrders();" value="print form elements" />
		</div>
	</c:if>
</c:if>

<script type="text/javascript" src="<ui:urlversioned value="/docs/approvals/approvalSteps.js" />"></script>
